//---------------------------------
// Receiver for RF remote control project
// (c) www.CoolCircuit.com
//---------------------------------
#include<pic.h>
#include"delay.h"

__CONFIG(XT&MCLRDIS&WDTDIS);

#define Header	0x20
#define RX  GP3
#define out1 GP0
#define out2 GP1
#define out3 GP2

unsigned char RXREG[3];

bit get_data(unsigned char *buff);


bit rx_bit;

void main()
{ 
	
	DelayBigUs(2430);
	GPIO=0x00;
	TRIS=0B00001000;
	OPTION=0x03;	
	
	while(1)
	{	
		while(get_data(RXREG));
		if (RXREG[2]==(RXREG[0] ^ RXREG[1]))
		{
			if (RXREG[0]==Header)
			{
				RXREG[1]=RXREG[1] & 0x03;
				if (RXREG[1]==0x01) out1=!out1;
				if (RXREG[1]==0x02) out2=!out2;
				if (RXREG[1]==0x03) out3=!out3;
			}
		}
		DelayMs(50);
	}
}	


bit get_data(unsigned char *buff)
{
	unsigned char i,j,T0,count;	
	
	i=16;		
	count=0;	
	OPTION=0x04;	// pre scaler = 32 for counting long time

	while(--i)	// wait preamble
	{		    
		 NOP();
	     NOP();
	     NOP();
	     while(RX);	     
	     TMR0=0;
	     NOP();
	     NOP();
	     NOP();
	     while(!RX);
	     T0=TMR0;
	     if (T0==0xFF) return 1;      // error
	     if ((T0>=146) && (T0<=166))	  // 4672-5312 uS it OK.   
	     {
		    count++;
		    if ((count>=5)|| (i==0)) break;
	     }	     
	}
	
	if (i==0) return 1; // error				
		
	OPTION=0x06;	// prescaler = 128
	T0=0;
	while (!((T0>=146) && (T0<=166)))	     // 18688 - 21248 uS it OK. syn bit
	{
		NOP();
	    NOP();
     	NOP();
		while(RX);	// wait syn
		TMR0=0;
		NOP();
		NOP();
	    NOP();
     	NOP();
		while(!RX);
		T0=TMR0;    
	}	
		
	while(RX); 			//wait start bit go low
	DelayBigUs(7355); 	// delay 7500 uS before sampling
	
	for (j=0;j<3;j++)
	{
	  i=8;
	  buff[j]=0;
	  while(i--)
	  {
		buff[j]=buff[j]<<1;
		rx_bit=RX;	// sampling
		buff[j]=buff[j] | rx_bit;			
		
		if (rx_bit==0) 
		   while(!RX);	
		else
		   while(RX);
		DelayBigUs(7355); 	// delay 7500 uS before sampling		
		
	  }
	}
	
	if (rx_bit==0) 
		if (!RX) return 1; // error (no stop bit found)
	else
		if (!RX) return 1; // error (no stop bit found)
		
	//*buff=TEMP[0];			
	return 0;
}	

